{% extends "base.html" %}
{% block title %} Create new film {% endblock %}
{% block content %}
<div id="movie-detail" class="list-view">
  <h2 class="title">Create new film</h2>
  <div class="list-item">
    <div v-if="created" class="alert alert-success">
      <b>Success!</b> <span>Movie is created successfully.</span>
    </div>
    <form @submit.prevent="save">
      <div class="field">
        <label>Name:</label>
        <input type="text" v-model="movie.name" />
        <div>
          <p class="error-message" v-for="err in checkError('name')">[[err]]</p>
        </div>
      </div>
      <div class="field">
        <label>Description:</label>
        <textarea rows="12" v-model="movie.description"></textarea>
        <div>
          <p class="error-message" v-for="err in checkError('description')">[[err]]</p>
        </div>
      </div>
      <div class="field">
        <label>Release Date:</label>
        <input type="date" v-model="movie.release_date" />
        <div>
          <p class="error-message" v-for="err in checkError('release_date')">[[err]]</p>
        </div>
      </div>
      <div class="field">
        <label>Rating:</label>
        <input type="range" min="1" max="5" v-model="movie.rating" />
        <div>
          <p class="error-message" v-for="err in checkError('rating')">[[err]]</p>
        </div>
      </div>
      <div class="field">
        <label>Ticket Price (PKR):</label>
        <input type="number" v-model="movie.ticket_price" />
        <div>
          <p class="error-message" v-for="err in checkError('ticket_price')">[[err]]</p>
        </div>
      </div>
      <div class="field">
        <label>Country:</label>
        <input type="text" v-model="movie.country" />
        <div>
          <p class="error-message" v-for="err in checkError('country')">[[err]]</p>
        </div>
      </div>
      <div class="field">
        <label>Genres</label>
        <select multiple v-model="movie.genres">
          <option v-for="genre in genres" :value="genre.id" :key="genre.id">[[genre.name]]</option>
        </select>
        <div>
          <p class="error-message" v-for="err in checkError('genres')">[[err]]</p>
        </div>
      </div>
      <div class="field">
        <label>Photo:</label>
        <input type="file" @change="filechange" />
        <div>
          <p class="error-message" v-for="err in checkError('photo')">[[err]]</p>
        </div>
      </div>
      <div class="action-control">
        <button>Save</button>
      </div>
    </form>
  </div>
</div>
{% endblock %}

{% block script %}
<script type="text/javascript">
  new Vue({
    delimiters: ['[[', ']]'], // default template tag has conflict with django template
    el: "#movie-detail",
    data: {
      genres: null,
      errors: null,
      created: false,
      movie: {
        name: null,
        release_date: null,
        rating: 1,
        ticket_price: null,
        description: null,
        country: null,
        genres: [],
        photo: null
      }
    },
    methods: {
      checkError(name) {
        if (this.errors) {
          if (this.errors[name]) {
            return this.errors[name]
          }
        }
      },
      restMovieForm() {
       this.movie = {
          name: null,
          release_date: null,
          rating: 1,
          ticket_price: null,
          description: null,
          country: null,
          genres: [],
          photo: null
        }
      },
      filechange(e) {
        this.movie.photo = e.target.files[0]
      },
      save() {
        const self = this
        self.errors = null
        self.created = false
        const formData = new FormData()
        for (const key of Object.keys(this.movie)) {
          if (key === 'genres') {
            const genres = this.movie[key]
            for (const i in genres) {
              formData.append('genres', genres[i])
            }
            continue
          }
          formData.append(key, this.movie[key])
        }
        CreateMovie(formData).then(function (res) {
          self.created = true
          window.scrollTo({ top: 0, behavior: 'smooth' });
          this.restMovieForm()
        }, function (err) {
          console.log(err)
          self.errors = err
        })
      }
    },
    mounted() {
      const self = this
      GetGenres().then(function (res) {
        self.genres = res
      })
    }
  })
</script>
{% endblock %}